"use strict";

exports.__esModule = true;
exports.default = transformFromAst;

var t = _interopRequireWildcard(require("babel-types"));

var _config = _interopRequireDefault(require("./config"));

var _transformation = _interopRequireDefault(require("./transformation"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function transformFromAst(ast, code, opts) {
  var config = (0, _config.default)(opts);
  if (config === null) return null;

  if (ast && ast.type === "Program") {
    ast = t.file(ast, [], []);
  } else if (!ast || ast.type !== "File") {
    throw new Error("Not a valid ast?");
  }

  return (0, _transformation.default)(config, code, ast);
}